if ( !isObject( "AIClientGroup" ) )
{
	new scriptGroup( "AIClientGroup" );
}

function addBot()
{
	%obj = new AIConnection()
	{
		name = "Bot " @ AIClientGroup.getCount();
		bl_id = -1;
		hasSpawnedOnce = true;
	};

	AIClientGroup.add( %obj );
	%obj.schedule( 0, "spawnPlayer" );

	return %obj;
}

function AIConnection::deleteBot( %this )
{
	if ( isObject( %pl = %this.player ) )
	{
		%pl.delete();
	}

	%this.delete();
}

function AIConnection::getPlayerName( %this )
{
	return %this.name;
}

function AIPlayer::getPlayerName( %this )
{
	return %this.client.name;
}

function kickBots()
{
	while ( AIClientGroup.getCount() )
	{
		AIClientGroup.getObject( 0 ).deleteBot();
	}
}

// AIGroup
if ( !isObject( "AIGroup" ) )
{
	new scriptGroup( "AIGroup" )
	{
		index = 0;
	};
}

function AIGroup::push( %this, %obj )
{
	if ( !%this.isMember( %obj ) )
	{
		%this.add( %obj );

		if ( !isEventPending( %this.tick ) )
		{
			%this.index = 0;
			%this.tick = %this.schedule( $AI::Rate, "tick" );
		}
	}
}

function AIGroup::pop( %this, %obj )
{
	if ( %this.isMember( %obj ) )
	{
		%this.remove( %obj );
	}
}

function AIGroup::tick( %this )
{
	cancel( %this.tick );
	%count = %this.getCount();

	if ( !%count )
	{
		%this.index = 0;
		return;
	}

	if ( %this.index >= %count )
	{
		%this.index = 0;
	}

	%start = %this.index;
	%index = %start;
	%procc = 0;
	%usage = 0;

	while ( %usage < $AI::Quota )
	{
		if ( %index >= %count )
		{
			%index = 0;
		}

		%obj = %this.getObject( %index );

		if ( %proch[ %obj ] )
		{
			break;
		}

		%proco[ %procc ] = %obj;
		%proch[ %obj ] = true;
		%procc++;

		%index++;
		%usage++;
	}

	%this.index = %index;

	for ( %i = 0 ; %i < %procc ; %i++ )
	{
		if ( !isObject( %obj = %proco[ %i ] ) || !%this.isMember( %obj ) )
		{
			continue;
		}

		%obj.tick();
	}

	%this.tick = %this.schedule( $AI::Rate, "tick" );
}