// ASL; Active Sound List
$ASL::Count = mFloor( $ASL::Count );

function asl_push( %pos, %db )
{
	if ( $ASL::Ignore[ %pos, %db ] )
	{
		return;
	}

	%index = $ASL::Count;

	$ASL::Count++;
	$ASL::Sound[ %index ] = %db;
	$ASL::Point[ %index ] = %pos;
	$ASL::Ignore[ %pos, %db ] = true;

	schedule( alxGetWaveLen( %db.fileName ), 0, "asl_pop", %index );
	schedule( 0, 0, "deleteVariables", "$ASL::Ignore" @ %pos @ "_" @ %db );

	if ( strLen( $Subtitle[ %db.getName() ] ) )
	{
		subtitleAll( $Subtitle[ %db.getName() ] );
	}
	else
	{
		subtitleAll( %db.getName() );
	}
}

function asl_pop( %index )
{
	for ( %i = %index ; %i < $ASL::Count ; %i++ )
	{
		$ASL::Sound[ %i ] = $ASL::Sound[ %i + 1 ];
		$ASL::Point[ %i ] = $ASL::Point[ %i + 1 ];
	}

	$ASL::Count--;
	$ASL::Sound[ $ASL::Count ] = "";
	$ASL::Point[ $ASL::Count ] = "";
}

package sound_package
{
	function gameConnection::play2D( %this, %db )
	{
		parent::play2D( %this, %db );

		if ( isObject( %db ) )
		{
			asl_push( "2D", %db );
		}
	}

	function gameConnection::play3D( %this, %db, %pos )
	{
		parent::play3D( %this, %db, %pos );

		if ( isObject( %db ) )
		{
			asl_push( %pos, %db );
		}
	}

	function player::playAudio( %this, %slot, %db )
	{
		parent::playAudio( %this, %slot, %db );
		asl_push( %this, %db );
	}
};

activatePackage( "sound_package" );

function AIPlayer::getSoundCount( %this )
{
	return $ASL::Count;
}

function AIPlayer::getSoundData( %this, %index )
{
	return $ASL::Sound[ %index ];
}

function AIPlayer::getSoundSource( %this, %index )
{
	return $ASL::Point[ %index ];
}