function AIPlayer::updateVision( %this )
{
	%this.visionSet.clear();

	%point = %this.getEyePoint();
	%range = %this.visionRange;
	%masks = $TypeMasks::StaticShapeObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::PlayerObjectType;
	initContainerRadiusSearch( %point, %range, %masks );

	while ( isObject( %obj = containerSearchNext() ) )
	{
		if ( objectInView( %this, %obj ) )
		{
			%this.visionSet.add( %obj );
		}
	}
}

function objectInView( %a, %b )
{
	if ( !isObject( %a ) || !isObject( %b ) )
	{
		return false;
	}

	%eye = %a.getEyePoint();
	%to = posFromTransform( %b.getTransform() );

	%ray = containerRaycast( %eye, %to, $TypeMasks::StaticShapeObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType, %a );
	%col = getWord( %ray, 0 );

	if ( isObject( %col ) && %col $= %b )
	{
		%pos = posFromRaycast( %ray );

		%resultant = vectorSub( %pos, %eye );
		%normal = vectorNormalize( %resultant );
		%resultRadians = mAtan( getWord( %normal, 1 ), getWord( %normal, 0 ) );
		
		%eyeVec = %a.getEyeVector();
		%eyeRadians = mAtan( getWord( %eyeVec, 1 ), getWord( %eyeVec, 0 ) );

		%resultDegrees = mRadToDeg( %resultRadians );
		%eyeDegrees = mRadToDeg( %eyeRadians );

		if ( %resultDegrees >= %eyeDegrees - %a.visionFOV / 2 && %resultDegrees <= %eyeDegrees + %a.visionFOV / 2 )
		{
			return true;
		}
	}
	
	return false;
}